diff --git a/lib/hive/commands/web_service.rb b/lib/hive/commands/web_service.rb
new file mode 100644
index 0000000..e5fe086
--- /dev/null
+++ b/lib/hive/commands/web_service.rb
@@ -0,0 +1,252 @@
+require "json"
+require "net/http"
+require "socket"
+require "hive/config"
+require "hive/paths"
+
+module Hive
+  module Commands
+    # `hive web install|start|stop|status` — manage the web UI as a per-user
+    # service (systemd-user on Linux, launchd on macOS), separate from
+    # `hive-daemon`. Bare `hive web` stays the foreground server; this class
+    # only handles the managed-service surface.
+    #
+    #   install [--force] [--no-autostart]  (Re)write the unit file. Without
+    #                                       --force, refuses to overwrite a
+    #                                       pre-existing unit (exit 64).
+    #   start                               Start via the service manager.
+    #   stop                                Stop via the service manager
+    #                                       (idempotent).
+    #   status [--json]                     Non-mutating probe: unit state,
+    #                                       /health, port liveness.
+    class WebService
+      include Hive::Schemas::EnvelopeEmitter
+
+      VALID_SUBCOMMANDS = %w[install start stop status].freeze
+
+      def initialize(subcommand, json: false, force: false, autostart: true,
+                     http: nil, runner: nil, installer: nil)
+        @subcommand = subcommand
+        @json = json
+        @force = force
+        @autostart = autostart
+        @http = http
+        @runner = runner
+        @installer = installer
+      end
+
+      def call
+        unless VALID_SUBCOMMANDS.include?(@subcommand)
+          raise Hive::InvalidTaskPath,
+                "hive web: unknown subcommand #{@subcommand.inspect} " \
+                "(expected: #{VALID_SUBCOMMANDS.join(', ')})"
+        end
+
+        call_with_envelope do
+          case @subcommand
+          when "install" then install
+          when "start"   then start
+          when "stop"    then stop
+          when "status"  then status
+          end
+        end
+      end
+
+      private
+
+      def envelope_schema
+        # Error envelopes under --json reuse the matching subcommand's wire
+        # contract; `start` has no dedicated schema (success-only surface),
+        # so its failures map to the install envelope's error shape.
+        case @subcommand
+        when "status" then "hive-web-status"
+        when "stop" then "hive-web-stop"
+        else "hive-web-install"
+        end
+      end
+
+      def installer
+        require "hive/commands/web/service_installer"
+        @installer ||= Hive::Commands::Web::ServiceInstaller.new(runner: @runner)
+      end
+
+      # ── install ──────────────────────────────────────────────────────
+
+      def install
+        result = installer.install!(autostart: @autostart, force: @force)
+
+        unless @json
+          installer.messages.each { |line| warn "hive: #{line}" }
+          case result.kind
+          when :written
+            puts "hive web: installed unit at #{installer.target_path}"
+          when :upgraded
+            msg = "hive web: upgraded unit at #{installer.target_path}"
+            msg += " (backup: #{result.backup_path})" if result.backup_path
+            puts msg
+          when :unchanged
+            puts "hive web: unit already up to date at #{installer.target_path}"
+          when :autostart_unavailable
+            puts "hive web: unit written at #{installer.target_path}; autostart not enabled on this host"
+          end
+        end
+
+        if @json
+          payload = {
+            "schema" => "hive-web-install",
+            "schema_version" => Hive::Schemas::SCHEMA_VERSIONS.fetch("hive-web-install"),
+            "ok" => true,
+            "outcome" => wire_outcome(result.kind),
+            "platform" => installer.envelope_platform,
+            "target_path" => installer.target_path,
+            "backup_path" => result.backup_path,
+            "restarted" => result.restarted,
+            "messages" => installer.messages
+          }
+          puts JSON.generate(payload)
+        end
+
+        return unless result.drifted?
+
+        raise Hive::Error,
+              "web unit at #{installer.target_path} differs from the current template. " \
+              "Re-run with `hive web install --force` to overwrite (a timestamped .bak " \
+              "will be saved)."
+      end
+
+      def wire_outcome(kind)
+        case kind
+        when :written, :upgraded, :unchanged, :unsupported then kind.to_s
+        when :autostart_unavailable then "unsupported"
+        when :failed, :drifted then kind.to_s
+        end
+      end
+
+      # ── start / stop ─────────────────────────────────────────────────
+
+      def start
+        unless File.exist?(installer.target_path.to_s)
+          raise Hive::Error,
+                "hive web: the web service is not installed. Run `hive web install` first."
+        end
+
+        ok = service_runner.call(start_argv)
+        if @json
+          puts JSON.generate(service_action_envelope("start", ok: ok))
+        elsif ok
+          puts "hive web: service start requested (#{service_label})"
+        else
+          raise Hive::Error, "hive web: the service manager refused start (#{service_label})"
+        end
+      end
+
+      def stop
+        unless File.exist?(installer.target_path.to_s)
+          # Idempotent: stopping a never-installed service is a no-op.
+          return puts JSON.generate(service_action_envelope("stop", ok: true)) if @json
+
+          warn "hive: web service not installed; nothing to stop"
+          return
+        end
+
+        ok = service_runner.call(stop_argv)
+        if @json
+          puts JSON.generate(service_action_envelope("stop", ok: ok))
+        elsif ok
+          puts "hive web: service stop requested (#{service_label})"
+        else
+          raise Hive::Error, "hive web: the service manager refused stop (#{service_label})"
+        end
+      end
+
+      def service_action_envelope(action, ok:)
+        {
+          "schema" => "hive-web-stop",
+          "schema_version" => Hive::Schemas::SCHEMA_VERSIONS.fetch("hive-web-stop"),
+          "ok" => ok,
+          "action" => action,
+          "platform" => installer.envelope_platform,
+          "unit_path" => installer.target_path
+        }
+      end
+
+      def start_argv
+        case installer.send(:platform)
+        when :linux then %w[systemctl --user start hive-web]
+        else ["launchctl", "load", installer.target_path]
+        end
+      end
+
+      def stop_argv
+        case installer.send(:platform)
+        when :linux then %w[systemctl --user stop hive-web]
+        else ["launchctl", "unload", installer.target_path]
+        end
+      end
+
+      def service_label
+        case installer.envelope_platform
+        when "linux" then "systemctl --user hive-web"
+        when "macos" then "launchctl local.hive-web"
+        else "unknown platform"
+        end
+      end
+
+      def service_runner
+        @runner ||= ->(argv) { system(*argv, out: File::NULL, err: File::NULL) }
+      end
+
+      # ── status ───────────────────────────────────────────────────────
+
+      def status
+        cfg = Hive::Config.load_global_web
+        bind = cfg.fetch("bind")
+        port = cfg.fetch("port").to_i
+        state = installer.service_state
+        health = probe_health(bind, port)
+        payload = {
+          "schema" => "hive-web-status",
+          "schema_version" => Hive::Schemas::SCHEMA_VERSIONS.fetch("hive-web-status"),
+          "ok" => true,
+          "platform" => state["platform"],
+          "unit_path" => state["unit_path"],
+          "service_installed" => state["service_installed"],
+          "service_enabled" => state["service_enabled"],
+          "url" => "http://#{bind}:#{port}",
+          "port_listening" => port_listening?(bind, port),
+          "health_ok" => health["ok"]
+        }
+        if @json
+          puts JSON.generate(payload)
+        else
+          puts "hive web: #{state["service_enabled"] ? "enabled" : "not enabled"} " \
+               "(#{state["service_installed"] ? "unit installed" : "unit missing"})"
+          puts "hive web: url #{payload["url"]}, health #{health["ok"] ? "ok" : "unreachable"}"
+        end
+        raise Hive::Error, "hive web: health check failed" unless health["ok"]
+      end
+
+      def probe_health(bind, port)
+        host = loopback?(bind) ? "127.0.0.1" : bind
+        http = @http || Net::HTTP
+        response = http.get_response(URI("http://#{host}:#{port}/health?deep=1"))
+        JSON.parse(response.body.to_s)
+      rescue StandardError
+        { "ok" => false }
+      end
+
+      def port_listening?(bind, port)
+        host = loopback?(bind) ? "127.0.0.1" : bind
+        Socket.tcp(host, port, connect_timeout: 1).close
+        true
+      rescue StandardError
+        false
+      end
+
+      def loopback?(bind)
+        value = bind.to_s
+        value == "localhost" || value.start_with?("127.") || value == "::1"
+      end
+    end
+  end
+end
diff --git a/lib/hive/config.rb b/lib/hive/config.rb
index da8bd31..5176637 100644
--- a/lib/hive/config.rb
+++ b/lib/hive/config.rb
@@ -7,6 +7,7 @@ require "hive/babysitter/interval"
 require "hive/permission_scope"
 require "hive/paths"
 require "hive/screenote/oauth_client"
+require "hive/web/auth_mode"
 
 module Hive
   module Config
@@ -373,6 +374,15 @@ module Hive
         "bind" => "127.0.0.1",
         "port" => 4567,
         "origin" => "http://127.0.0.1:4567",
+        # Local-mode auth selector (`hive web`). `auto` (default) resolves at
+        # runtime: a loopback bind with no configured github.owner grants a
+        # tokenless local session (single-user contract); anything else falls
+        # through to the GitHub device-flow owner gate. `none` forces the
+        # tokenless session (still refused on a non-loopback bind unless
+        # `--allow-public-noauth`); `github` forces the device-flow gate even
+        # on loopback. The Docker/hivebox path always resolves to `github`
+        # once an owner is claimed, so its behavior is unchanged.
+        "auth" => "auto",
         "github" => {
           "owner" => nil,
           # The shared hivebox OAuth app (device flow only — public by
@@ -2277,6 +2287,13 @@ module Hive
               "web.origin in #{describe_source(source_path)} must be an http(s) URL"
       end
 
+      auth = web["auth"]
+      unless Web::AuthMode::AUTH_MODES.include?(auth)
+        raise ConfigError,
+              "web.auth in #{describe_source(source_path)} must be one of " \
+              "#{Web::AuthMode::AUTH_MODES.join(', ')}; got #{auth.inspect}"
+      end
+
       github = web["github"]
       unless github.is_a?(Hash)
         raise ConfigError,
diff --git a/lib/hive/daemon/consistency_probe.rb b/lib/hive/daemon/consistency_probe.rb
new file mode 100644
index 0000000..f303514
--- /dev/null
+++ b/lib/hive/daemon/consistency_probe.rb
@@ -0,0 +1,192 @@
+require "shellwords"
+require "open3"
+require "hive/invoked_binary"
+require "hive/paths"
+
+module Hive
+  module Daemon
+    # Read-only probe for daemon/CLI binary consistency (U5). Detects the
+    # drift modes that leave a box with a daemon that is running but not the
+    # one the operator thinks it is:
+    #
+    #   unit_path   — the installed unit (systemd-user / launchd) bakes an
+    #                 ExecStart=/HIVE_BIN= path that differs from the binary
+    #                 the invoking CLI resolved (e.g. a stale unit pointing
+    #                 at /usr/bin/hive while the CLI lives in ~/.local/bin).
+    #   live_binary — the live daemon process's argv binary differs from the
+    #                 invoking CLI's binary.
+    #
+    # The probe NEVER writes, signals, or repairs. Repair is always the
+    # existing `hive daemon install --force`, which restarts the service with
+    # the resolved binary and keeps a timestamped backup.
+    class ConsistencyProbe
+      DRIFT_NONE       = "none"
+      DRIFT_UNIT_PATH  = "unit_path"
+      DRIFT_LIVE_BIN   = "live_binary"
+
+      Result = Struct.new(:running, :pid, :cli_bin_path, :unit_bin_path,
+                          :live_bin_path, :live_version_matches, :drift_kind,
+                          keyword_init: true) do
+        def drifted?
+          drift_kind != DRIFT_NONE
+        end
+
+        def to_h
+          {
+            "running" => running,
+            "pid" => pid,
+            "cli_bin_path" => cli_bin_path,
+            "unit_bin_path" => unit_bin_path,
+            "live_bin_path" => live_bin_path,
+            "live_version_matches" => live_version_matches,
+            "drift_kind" => drift_kind
+          }
+        end
+      end
+
+      def initialize(pid: nil, unit_path: nil, cli_bin_path: nil,
+                     unit_reader: nil, argv_reader: nil, env: ENV)
+        @pid = pid
+        @unit_path = unit_path
+        @cli_bin_path = cli_bin_path
+        @unit_reader = unit_reader
+        @argv_reader = argv_reader
+        @env = env
+      end
+
+      def call
+        cli = resolved_cli_binary
+        unit_bin = read_unit_binary
+        live_bin = live_process_binary(cli)
+
+        live_matches =
+          if live_bin.nil? || cli.nil?
+            nil
+          else
+            same_file?(live_bin, cli)
+          end
+
+        drift =
+          if unit_bin && cli && !same_file?(unit_bin, cli)
+            DRIFT_UNIT_PATH
+          elsif live_matches == false
+            DRIFT_LIVE_BIN
+          else
+            DRIFT_NONE
+          end
+
+        Result.new(
+          running: !@pid.nil?,
+          pid: @pid,
+          cli_bin_path: cli,
+          unit_bin_path: unit_bin,
+          live_bin_path: live_bin,
+          live_version_matches: live_matches,
+          drift_kind: drift
+        )
+      end
+
+      private
+
+      def resolved_cli_binary
+        return @cli_bin_path if @cli_bin_path
+
+        Hive::InvokedBinary.path(env: @env)
+      end
+
+      # Extract the baked binary path from the unit file. Handles both the
+      # ExecStart= line (first shellwords token of `ExecStart=<bin> daemon start`)
+      # and the HIVE_BIN= environment line; ExecStart wins (it is what the
+      # service manager actually runs).
+      def read_unit_binary
+        path = @unit_path || default_unit_path
+        return nil unless path
+
+        if @unit_reader
+          content = @unit_reader.call(path)
+        else
+          return nil unless File.readable?(path)
+
+          content = File.read(path)
+        end
+        exec_start = content.lines.find { |l| l.start_with?("ExecStart=") }
+        if exec_start
+          tokens = Shellwords.split(exec_start.sub(/\AExecStart=/, "").strip)
+          return File.expand_path(tokens[0]) if tokens[0] && !tokens[0].empty?
+        end
+
+        hive_bin = content.lines.find { |l| l.start_with?("Environment=HIVE_BIN=") }
+        if hive_bin
+          value = hive_bin.sub(/\AEnvironment=HIVE_BIN=/, "").strip
+          return File.expand_path(value) unless value.empty?
+        end
+
+        nil
+      rescue StandardError
+        nil
+      end
+
+      def default_unit_path
+        host_os = RbConfig::CONFIG["host_os"].to_s
+        case host_os
+        when /darwin/i then File.join(home, "Library/LaunchAgents/local.hive-daemon.plist")
+        when /linux/i then File.join(home, ".config/systemd/user/hive-daemon.service")
+        end
+      end
+
+      # The live process's argv binary: /proc/<pid>/cmdline on Linux,
+      # `ps -o command= -p <pid>` on macOS. Returns nil when the process is
+      # gone or argv cannot be read — never raises.
+      def live_process_binary(_cli)
+        return nil unless @pid
+
+        raw = @argv_reader ? @argv_reader.call(@pid) : read_process_argv(@pid)
+        return nil if raw.nil? || raw.strip.empty?
+
+        tokens = raw.strip.split(/[[:space:]]+/)
+        argv0 = tokens[0]
+        # launchd wraps the real invocation in `/bin/sh -c '…; exec "$0" "$@"'
+        # — argv0 is /bin/sh and the real binary is the first absolute-path
+        # hive binary token after the script (the script itself contains no
+        # absolute paths). Handles both the NUL-split /proc form and the
+        # space-joined `ps -o command=` form.
+        if File.basename(argv0.to_s) == "sh"
+          real = tokens.drop(1).find do |t|
+            t.start_with?("/") && %w[hive hv].include?(File.basename(t))
+          end
+          return real ? File.expand_path(real) : nil
+        end
+        File.expand_path(argv0)
+      rescue StandardError
+        nil
+      end
+
+      def read_process_argv(pid)
+        cmdline = "/proc/#{pid}/cmdline"
+        if File.readable?(cmdline)
+          return File.read(cmdline).split("\0").reject(&:empty?).join(" ")
+        end
+
+        # macOS / non-Linux fallback.
+        out, _err, status = ::Open3.capture3("ps", "-o", "command=", "-p", pid.to_s)
+        status.success? ? out : nil
+      rescue StandardError
+        nil
+      end
+
+      def same_file?(a, b)
+        return a == b if a.nil? || b.nil?
+
+        ra = a.start_with?("/") && File.exist?(a) ? File.realpath(a) : File.expand_path(a)
+        rb = b.start_with?("/") && File.exist?(b) ? File.realpath(b) : File.expand_path(b)
+        ra == rb
+      rescue StandardError
+        a == b
+      end
+
+      def home
+        ENV.fetch("HOME") { Dir.home }
+      end
+    end
+  end
+end
diff --git a/lib/hive/qmd_lookup.rb b/lib/hive/qmd_lookup.rb
new file mode 100644
index 0000000..de57aac
--- /dev/null
+++ b/lib/hive/qmd_lookup.rb
@@ -0,0 +1,43 @@
+module Hive
+  # Shared qmd binary discovery. Extracted from Doctor so `hive setup`
+  # (DependencyChecks) and `hive doctor` agree on what "qmd is installed"
+  # means — same precedence, same managed locations:
+  #   1. HIVE_QMD_BIN (explicit override, must be executable)
+  #   2. qmd on PATH
+  #   3. The Hive-managed npm prefix installs:
+  #      $XDG_DATA_HOME/hive/qmd/bin/qmd, ~/.local/share/hive/qmd/bin/qmd,
+  #      and the install.sh-recorded install prefix location.
+  module QmdLookup
+    module_function
+
+    def qmd_bin(env: ENV)
+      env_qmd = env["HIVE_QMD_BIN"].to_s
+      return env_qmd if !env_qmd.empty? && File.executable?(env_qmd)
+
+      path_qmd = which("qmd", env: env)
+      return path_qmd if path_qmd
+
+      data_home = env["XDG_DATA_HOME"].to_s.empty? ? File.expand_path("~/.local/share") : env["XDG_DATA_HOME"]
+      candidates = [
+        File.join(data_home, "hive", "qmd", "bin", "qmd"),
+        File.expand_path("~/.local/share/hive/qmd/bin/qmd")
+      ]
+
+      prefix_file = File.join(data_home, "hive", "install-prefix")
+      if File.readable?(prefix_file)
+        prefix = File.read(prefix_file).lines.first.to_s.strip
+        candidates << File.join(prefix, "hive", "qmd", "bin", "qmd") unless prefix.empty?
+      end
+
+      candidates.find { |candidate| File.file?(candidate) && File.executable?(candidate) }
+    end
+
+    def which(name, env: ENV)
+      env.fetch("PATH", "").split(File::PATH_SEPARATOR).each do |dir|
+        path = File.join(dir, name)
+        return path if File.file?(path) && File.executable?(path)
+      end
+      nil
+    end
+  end
+end
diff --git a/lib/hive/web/auth_mode.rb b/lib/hive/web/auth_mode.rb
new file mode 100644
index 0000000..b1239dd
--- /dev/null
+++ b/lib/hive/web/auth_mode.rb
@@ -0,0 +1,57 @@
+# frozen_string_literal: true
+
+module Hive
+  module Web
+    # Auth-mode selector for the web UI (`web.auth` config key + the
+    # `HIVEBOX_LOCAL_NOAUTH` runtime env it exports).
+    #
+    # Modes:
+    #   auto    — resolved at start time: a loopback bind with no configured
+    #             github.owner grants a tokenless local session; everything
+    #             else falls through to the GitHub device-flow owner gate.
+    #   none    — force the tokenless local session. The CLI refuses to boot
+    #             it on a non-loopback bind unless `--allow-public-noauth`.
+    #   github  — force the device-flow owner gate, even on loopback.
+    #
+    # This constant lives beside Hive::Config (which validates the enum) and
+    # is required by both `hive web` and the Rails app (application_controller
+    # reads the exported env), so the three surfaces cannot drift.
+    module AuthMode
+      AUTO   = "auto"
+      NONE   = "none"
+      GITHUB = "github"
+
+      AUTH_MODES = [AUTO, NONE, GITHUB].freeze
+
+      # The env var `hive web` exports to the Rails process when the resolved
+      # auth mode is `none`. The controller grants a tokenless loopback
+      # session only when this is set AND the request's remote_ip is loopback
+      # (defense in depth — see ApplicationController#require_login).
+      LOCAL_NOAUTH_ENV = "HIVEBOX_LOCAL_NOAUTH"
+
+      # Resolve the effective auth mode for a config:
+      #   1. An explicit `web.auth` config value (none/github) always wins.
+      #   2. `auto` → `github` when a github.owner is configured (the
+      #      device-flow owner gate exists, Docker's contract), else `none`
+      #      (no gate to authenticate against). Whether `none` may actually
+      #      boot is decided by the CLI refusal matrix: loopback binds are
+      #      granted the tokenless session; non-loopback binds are refused
+      #      unless --allow-public-noauth.
+      def self.resolve(cfg)
+        configured = cfg["auth"]
+        return configured if [ NONE, GITHUB ].include?(configured)
+
+        owner = cfg.dig("github", "owner")
+        owner.to_s.strip.empty? ? NONE : GITHUB
+      end
+
+      def self.loopback_bind?(bind)
+        value = bind.to_s.strip
+        return true if value == "localhost"
+        return true if value.start_with?("127.")
+
+        value == "::1" || value == "[::1]"
+      end
+    end
+  end
+end
